/*
** Copyright (C) 1998,1999,2000,2001 Martin Roesch <roesch@clark.net>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

/* $Id: avl_tree.h,v 1.3 2001/05/12 20:25:10 roesch Exp $ */
#ifndef __AVLTREE_H__
#define __AVLTREE_H__

#include <stdlib.h>
#include <stdio.h>
#include "spp_tcp_stream3.h"

int nodecount;

void inserttree(int newdata, struct Node **, int maxdepth);
void checkbalance(struct Node * start);
void deletenode(int newdata, struct Node ** start, struct Node **);
void insertnode(int newdata, struct Node ** start, int depth, int maxdepth);
struct Node * findnode(struct Node *, int newdata);
void printavltree(struct Node *);
void rotateleft(struct Node ** start);
void rotateright(struct Node ** start);
void balanceleft(struct Node ** start);
void balanceright(struct Node ** start);
void countnodes(struct Node *);
void walkavltree(void (*callback)(struct Node*), struct Node *start);

#endif  /* __AVLTREE_H__  */

